/***************************************************
  Abstimmer.ino
  This is a simple Neopixel-APP by Jakob Vicari
  for Neopixel-Rings based on Adafruit library examples
   Distributen under MIT-License
 ****************************************************/

#include <neopixel.h>   // Hier sind die Neopixel-Codes


#define PIXEL_PIN D2    // Der LED-Ring hängt an Pin D2
#define PIXEL_COUNT 20  // Der LED-Ring hat 20 einzelne Pixel
#define PIXEL_TYPE WS2813 // Der Typ vom LED Ring Controller (aufgedruckt)

int mentions_sum=1, mentions_pos =1, mentions_neg = 1, fakt24, leds_pos, leds_neg;

Adafruit_NeoPixel strip(PIXEL_COUNT, PIXEL_PIN, PIXEL_TYPE);    // Den Neopixel-Ring initialisieren

void rainbow(uint8_t wait);
uint32_t Wheel(byte WheelPos);

int countMention(String command)        // Diese Funktion wird über IFTTT aufgerufen und schickt den Tweettext mit

{  uint16_t i, j;

  if (strstr(command, "#bravo") != NULL)    // Wenn im Tweet der Hashtag #bravo, dann grün erhöhen
   {
      mentions_pos = mentions_pos +1;
  }
if (strstr(command, "#boring") != NULL)  // Wenn im Tweet der Hashtag #boring, dann rot erhöhen
   {
      mentions_neg = mentions_neg +1;
  }

 if (strstr(command, "#finish") != NULL)  // Wenn im Tweet der Hashtag #finish, dann Regenbogen zeigen
   {

  for(j=0; j<50; j++) {
      rainbow(100); }

  }
}

void setup()
{
  Particle.function("countMention", countMention);  // Die Funktion counTMention in der Cloud für IFTTT sichtbar machen
  strip.begin(); // Neopixel-Ring initialisieren
  strip.show(); // Alle LEDs ausschalten

}

void loop()
{

  mentions_sum = mentions_pos + mentions_neg; // Zahl der Gesamt-Erwähnungen positiv + negativ
  greenleds(mentions_pos * 24/mentions_sum); // Daraus errechnen: Zahl der grünen Leds;
  redleds(mentions_neg * 24/mentions_sum); // Daraus errechnen: Zahl der roten Leds;
  delay(100);
}


void greenleds (uint8_t leds_pos) {  // grüneLEDS zeigen
  uint16_t i, j;

    for(i=0; i<=leds_pos; i++) {
      strip.setPixelColor(i, Wheel((65) & 255)); // GRÜN
    }
    strip.show();

}


void redleds (uint8_t leds_neg) {           // rote LEDS zeigen
  uint16_t i, j;

    for(i=0; i<=leds_neg; i++) {
      strip.setPixelColor(24-i, Wheel((255) & 255)); // knallrot
    }
    strip.show();

}

void rainbow(uint8_t wait) {            // Regenbogen
  uint16_t i, j;

  for(j=0; j<256; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  if(WheelPos < 85) {
   return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  } else if(WheelPos < 170) {
   WheelPos -= 85;
   return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } else {
   WheelPos -= 170;
   return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
}
