/*  Boden Bodo by Jakob Vicari, 2019
    Based on
    Soil Mositure Basic Example
    This sketch was written by SparkFun Electronics
    Joel Bartlett
    August 31, 2015

    Basic skecth to print out soil moisture values to the Serial Monitor

    Released under the MIT License(http://opensource.org/licenses/MIT)
*/

int val = 0; //Hier kommt der Feuchte-Messwert rein
int soilPin = A0;//Eine Variable für den Pin
int soilPower = D7;//Variable für Bodenfeuchte-Power (verhindert korrosion)
int soilMeasurement = 0;


int messeBodenfeuchte()         // Das ist die Funktion zum Messen
{
    digitalWrite(soilPower, HIGH);//Sensorstrom "AN"
    delay(10);//10 Millisekunden warteb
    val = analogRead(soilPin);//Den Sensor auslesebn
    digitalWrite(soilPower, LOW);//Sensorstrom "AUS"
    return val;//Den Messwert zurückgeben
}

void setup() // Das im SETUP einmal beim Start tun
{
  pinMode(soilPower, OUTPUT);//Der D7-PIN ist der Stromversorgungs-Pin für unseren Sensor
  digitalWrite(soilPower, LOW);//Stromversorgung auf LOW = AUS
  Particle.variable ("Boden", soilMeasurement); //Den Feuchte-Messwert  auch in eine Particle-Variable schreiben
}

void loop() // Das im LOOP immer wieder tun
{

soilMeasurement = messeBodenfeuchte(); // Bodenfeuchte messen
Particle.publish("Boden-Bodo", "Feuchte:"+String(soilMeasurement)); // Bodenfeuchtewert veröffentlichen. Sichtbar in der Particle Console. Eigentlich doppelt gemoppelt, weil ist ja schon eine Particle Variable

delay(1000);//Eine Sekunde wartenb
}
