/***************************************************
  This is a simple NEWSBOT-APP by Jakob Vicari
  for Waveshare eink-Dsisplays 2.9b based on library examples
   Distributen under MIT-License
 ****************************************************/

#include <WaveshareEPaper29b.h>
#include <Wire.h>

const int oled_maxx = 128;          // display max pixel x
const int oled_maxy = 296;           // display max pixel y

#define COLORED     0
#define UNCOLORED   1

extern const unsigned char IMAGE_BLACK[];
extern const unsigned char IMAGE_RED[];
#define WIDTH  128
#define HEIGHT 296

unsigned char black[(WIDTH * HEIGHT) / 8]; //[296*128];
unsigned char red[(WIDTH * HEIGHT) / 8]; //[296*128];

unsigned char image[1024];

const int pRESET = D8;
const int pDC    = D9;
const int pCS    = D10;
const int pBUSY  = D7;

Epd   epd(SPI, pCS, pDC, pRESET, pBUSY);


Paint paint(black, WIDTH, HEIGHT);
Paint paintRed(red, WIDTH, HEIGHT);


void newsbot_event(const char *event, const char *data)   // abonnieren wenn ein Ereignis an alle Newsbots gesendet wird
{
  show_text(data,1, true, true);
}


char line_breaker (String otext, int maxline) // Zeilenumbrüche einfügen
{
    String newtext;
    int i;
    int line=0;
    int space_marker=maxline;
         for(i = 0; i < (otext.length()); i=i+space_marker+1)   // Schleife durch die Zeichen des Strings, weiter um die letzte Zeile (space_marker)
         {
         newtext = otext.substring(i,i+maxline);   // etwas unelegant
         space_marker = newtext.lastIndexOf(" "); // Nach dem letzten Leerzeichen suchen
         if (space_marker <= (maxline-8)) {space_marker = maxline+1;}

         newtext = otext.substring(i,i+space_marker);   // Newtext für letztes Leerzeichen korrigieren
         paint.DrawStringAt(line, 0, newtext, &Font16, UNCOLORED);

         line++;                                // Zeilennummer aufzählen
        }
}

int show_text (String text, int line, bool linebreak, bool clear)       // Text auf Display zeigen

{
    text = text.replace("ö", "oe");  text = text.replace("Ö", "Oe");        // Font kann keine Umlaute, German
    text = text.replace("ü", "ue");  text = text.replace("Ü", "Ue");
    text = text.replace("ä", "ae");  text = text.replace("Ä", "Ae");
    text = text.replace("ß", "ss");

     if (line >=8)
       {line =8;}
      if (clear==true) {paint.Clear(UNCOLORED);}          //clear the screen and set start position to top left corner
      if (linebreak = true){line_breaker(text,(oled_maxx/8));}
      else paint.DrawStringAt(1, 1, text, &Font16, UNCOLORED);  // Zeige den Text an
      delay(2000);
      return 0;

}

int receive_text(String text)                   // für ifttt.com erreichbar
{
    show_text (text,1, true, true);
    return 0;
}



void setup()    // Das wird einmal gemacht
{
  Wire.begin();
  Particle.function("receive_text", receive_text); // Function should be reached by IFTTT
  Particle.subscribe("newsbot_event", newsbot_event, ALL_DEVICES); // receive alle events for BNewsbots
  epd.Init(); //Waveshare Display Init
  epd.ClearFrame();
  paint.Clear(UNCOLORED);
  show_text("Newsbot: System starts ...",2, false, true); //Print the String
  show_text("Newsbot: Waiting for News",3,false, false); //Print the String

}

void loop()  // Es tut nichts von selbst, außer es wird aus der Cloud etwas aufgerufen
{

}
