/***************************************************
 DFRobot Gravity: Analog Sound Level Meter
 <https://www.dfrobot.com/wiki/index.php/Gravity:_Analog_Sound_Level_Meter_SKU:SEN0232>

 ***************************************************
 This sample code is used to test the analog sound level meter.

 Created 2017-06-26
 By Jason <jason.ling@dfrobot.com@dfrobot.com>
 Adapted for Soundstein by Jakob Vicari, 2019

 GNU Lesser General Public License.
 See <http://www.gnu.org/licenses/> for details.
 All above must be included in any redistribution
 ****************************************************/

#define VREF 3.3  //voltage on AREF pin,default:operating voltage
const double calibration = 0; // manual calibration

int SoundSensorPin = A1;
int led1 = D7;
unsigned long old_time = 0;

void setup()
{
    pinMode(led1,OUTPUT);
    pinMode(SoundSensorPin,INPUT);
    Serial.println ("Soundsensor gestartet & im Netz");
    Particle.publish("dBA_status","Soundsensor gestartet & im Netz",PUBLIC);
    digitalWrite(led1, HIGH);  // LED kurz aufblinken lassen
    delay(200);
    digitalWrite(led1, LOW);
    delay(300);
    digitalWrite(led1, HIGH);

}

void loop()
{
    float voltageValue,dbValue;

    voltageValue = analogRead(SoundSensorPin) / 4096.0 * VREF;
    dbValue = voltageValue * 50.0;  //convert voltage to decibel value
      String dbA_measurement = String(dbValue+calibration,1); // + calibration
      Particle.publish("dBA_measurement",dbA_measurement,PUBLIC);

 }
    delay(5000);
}
